## 0.6.1
> 发布于 2023.03.01

#### 功能

- 新增路由通配符`*`匹配。


#### 修复

- 修复初始配置加载异常的问题。


#### 变更

- 升级依赖库 ```lua-resty-oakrouting```，由```0.1.0-1```变更为```0.2.0-1```。
- 变更所有依赖库为本地化安装。



## 0.6.0
> 发布于 2023.01.01

#### 功能

- 重构流量服务主体设计框架。
- 重构配置加载机制。
- 新增网关命令行支持。
- 新增自定义多域名支持。
- 新增无上游自动解析域名支持。
- 新增服务证书管理支持。
- 新增流量请求动态证书支持。
- 升级 ```Admin API``` 功能。
- 新增跨域配置插件。
- 新增流量请求速率限制插件。


#### 变更

- 固定域名服务变更为自定义域名服务。
- 上游绑定由 ```项目``` 变更为 ```路由``` 。
- ```Mock``` 功能插件化。
- 移除上游健康检查。
- 移除项目成员，弱化用户管理功能。
- 全新的UI设计，简化页面操作与配置。
- 存储引擎由 ```mysql``` 变更为 ```consul```。
- 新增依赖库 ```lua-resty-consul```。
- 新增依赖库 ```lua-resty-jit-uuid```。
- 新增依赖库 ```lua-resty-dns```。
- 移除依赖库 ```lua-resty-healthcheck```。
- 移除依赖库 ```lua-resty-mysql```。


#### 文档

- 更新依赖安装文档，`MariaDB` 安装变更为 `Consul` 安装文档。



## 0.5.0
> 发布于 2020.06.08

#### 功能

- 新增 ```IPV6``` 的支持。
- 新增环境检查功能。
- 新增 ```Admin API``` 测试用例。
- 新增 ```Load balancing``` 健康检查功能。
- 新增路由表内存池回收功能。


#### 修复

- 修复 ```SQL``` 注入漏洞。


#### 变更

- 新增依赖库 ```lua-resty-oakrouting```。
- 新增依赖库 ```lua-resty-healthcheck```。
- 移除依赖库 ```lua-resty-libr3```。
- 路由引擎由 ```libr3``` 变更为 ```oakrouting```。


#### 文档

- 新增中文使用文档。
- 更新 ```MariaDB``` 中文安装文档。



## 0.4.0
> 发布于 2020.04.06

#### 功能

- 重构网关内核模块。
- 重构控制台管理面板（此版本强大易用，强烈推荐）。
- 重构 `项目`、`路由` 管理后台 `APIs`。
- 新增 `账号`、`用户`、`公共服务` 管理后台 `APIs`。
- 配置中心由 `ETCD` 更换为 `MariaDB` 数据库。
- 新增 `项目` 管理。
  - 支持项目前缀，用于多租户隔离。
  - 支持多环境环境配置，`生产环境`、`预发环境`、`测试环境` 不同环境完全隔离，满足`持续集成`、`持续交付`的全生命周期管理。
  - 支持动态加权的 `round-robin` 负载均衡。
  - 支持动态一致性 `hash` 负载均衡。
  - 支持动态节点配置，动态 `Host` 配置。
  - 支持上游服务 `连接`、`发送`、`读取` 超时设置。
  - 支持插件热插拔，项目插件可被项目下所有路由继承。
  - 支持自动生成项目文档。
  - 支持项目成员管理。
- 新增 `路由` 管理。
  - 支持前后端请求路由映射。
  - 支持前后端请求方式映射。
  - 支持前后端请求参数交叉映射。
  - 支持常量参数定义。
  - 支持自定义响应数据及响应数据类型。
  - 支持插件热插拔。
  - 支持 `Mock` 请求，加速前后端分离开发过程。
  - 支持自动生成路由（APIs）文档。
  - 支持多环境路由（APIs）上下线。
  - 支持多环境路由（APIs）一键复制。
- 新增 `用户` 管理。
  - 支持用户登录、注册。
  - 支持用户创建、编辑、删除。
  - 支持用户全局禁用。


#### 变更

- 移除依赖库 `lua-resty-template`。
- 移除依赖库 `lua-resty-etcd`。
- 移除依赖库 `lua-resty-ngxvar`。
- 移除依赖库 `lua-resty-jit-uuid`。
- 移除 `0.3.0` 版本中 `Service` 模块和相关管理API、文档。
- 移除 `0.3.0` 版本中 `Plugin` 模块和相关管理API、文档。
- 移除 `0.3.0` 版本中 `Router` 模块和相关管理API、文档。


## 0.3.0
> 发布于 2020.01.29

#### 功能

- 新增 `Dashboard` 管理面板。
- 新增 `Balancer` 健康检查。
- 新增 `Jwt Auth` 插件参数验证结构。
- 新增 `Key Auth` 插件参数验证结构。
- 新增 `Limit Conn` 插件参数验证结构。
- 新增 `Limit Count` 插件参数验证结构。
- 新增 `Limit Req` 插件参数验证结构。


#### 修复

- 修复 `Jwt Auth` 插件单元测试错误。


#### 变更

- 变更 `Limit Count` 插件配置字段。
- 变更插件列表API参数描述信息。
- 删除冗余测试用例文件。



## 0.2.0
> 发布于 2020.01.12

#### 功能

- 新增 `JWT` 插件。
- 新增 CentOS `RPM` 安装方式。
- 新增 Ubuntu `DEB` 安装方式。
- 新增 测试用例基础请求模块。
- 新增 上游 `uri` 重写功能。
- 新增 `admin.plugin` 测试用例。
- 新增 `admin.router` 测试用例。
- 新增 `admin.service` 测试用例。
- 新增 `pdk.admin` 测试用例。
- 新增 `pdk.config` 测试用例。
- 新增 `pdk.const` 测试用例。
- 新增 `pdk.etcd` 测试用例。
- 新增 `pdk.json` 测试用例。
- 新增 `pdk.log` 测试用例。
- 新增 `pdk.table` 测试用例。
- 新增 `plugin.jwt-auth` 测试用例。
- 新增 `plugin.key-auth` 测试用例。
- 新增 `plugin.limit-conn` 测试用例。
- 新增 `plugin.limit-count` 测试用例。
- 新增 `plugin.limit-req` 测试用例。


#### 修复

- 修复 `key-auth` 认证插件逻辑错误问题。
- 修复 `README.md` 拼写错误。


#### 变更

- 变更 `key-auth` 认证插件配置读取从 `etcd` 到 `oak_ctx`。
- 更新赞助链接。


#### 文档

- 增加 `如何参与贡献` 文档。



## 0.1.0
> 发布于 2020.01.01

#### 功能

- 新增 基础框架。
- 新增 `service`、`router`、`plugin` 和 `upstream` 管理功能。
- 新增 动态轮询负载均衡功能。
- 新增 基于一致性哈希负载均衡功能。
- 新增 多环境路由发布功能。
- 新增 `Mock` 请求功能。
- 新增 命令行管理脚本。
- 新增 `Makefile` 自动化 `安装` 和 `卸载` 功能。
- 新增 基础测试框架 `TEST-NGINX`。
- 新增 `key-auth` 身份验证插件。
- 新增 `limit-conn` 流量控制插件。
- 新增 `限制计数` 流量控制插件。
- 新增 `limit-req` 流量控制插件。
- 新增 `PDKs` 开发套件。
- 新增 请求重写和参数转换功能。
- 新增 API验证参数框架 `JSON-SCHEMA`。


#### 文档

- 新增 `service` 管理文档。
- 新增 `router` 管理文档。
- 新增 `plugin` 管理文档。
- 新增 `系统依赖` 安装文档。
